

FAQ How do I use the keyboard to traverse between editors?
==========================================================

The keyboard can be used in several ways to traverse between editors.

  

*   A pop-up list of all open editors in most recently used order will be shown when you press Ctrl+F6 and don't release the Ctrl key. Move backward in this list using Ctrl+Shift+F6.

  

*   Create new key bindings for the **Next Editor** and **Previous Editor** commands in the **Workbench > Keys** preference page, under the **Window** category. Many users find that binding these commands to Ctrl+` and Ctrl+Shift+` (the key directly above Tab on U.S.-English keyboards) makes editor switching much like the Alt+Tab and Alt+Shift+Tab that many window managers use to switch applications.

  

*   Use Alt+Left and Alt+Right-or click the **Forward** and **Back** buttons in the toolbar-to move around in the editor navigation history, much as you would in a Web browser.

  

*   Press Ctrl+Shift+E to open a dialog of all open editors, type the first letter of the editor input name to pick the editor of choice from the list, and press Enter. This is a quick way to get random access in a large group of open editors.

  

*   Press Ctrl+E (Eclipse 3.0 only) to open a drop-down list of open editors when the tabs do not fit on the screen. Start typing the editor name in this list to pick the editor you want to activate.

  

*   Press Alt+F to open the file menu; then press the number of the editor of choice from the editor history list at the bottom of the menu. This is the easiest way to jump quickly to an editor that has recently been closed.

  

*   Press Ctrl+Shift+R to open the Open Resource dialog and find your editor in the list (or Ctrl+Shift+T for Java types). This can be used to switch to an editor whether or not it is already open.

  

  
This seemingly long list of choices has probably been the most hotly debated usability issue in Eclipse over the years. Attempts to change or remove any of these features in the past have resulted in passionate criticism, with everyone having a favorite technique for navigating the environment. The lesson for plug-in developers? Sometimes, you have to provide more than one way to do the same thing. Always keep keyboard-only users-and this includes visually impaired users-in mind. The Eclipse team has been known to have mouse-free days, when mice are unplugged to make sure that everything in the environment is accessible without a mouse.

  

  

See Also:
---------

[FAQ\_What\_editor\_keyboard\_shortcuts\_are\_available?](./FAQ_What_editor_keyboard_shortcuts_are_available.md "FAQ What editor keyboard shortcuts are available?")

  
[FAQ\_How\_do\_I\_open\_a\_type\_in\_a\_Java\_editor?](./FAQ_How_do_I_open_a_type_in_a_Java_editor.md "FAQ How do I open a type in a Java editor?")

