FAQ What is new in Eclipse 3.0?
===============================

Attempting to enumerate all of new features and APIs in Eclipse 3.0 would be futile. The past year or so of development has focused on more than 50 major features of the Eclipse 3.0 plan, not to mention addressing more than 5,000 bugs and feature requests, according to a quick query of the Eclipse Bugzilla. The best place to get an overview of major new changes in Eclipse 3.0 is to read through all the _New and Noteworthy_ documents included with each milestone build.

To give you a quick summary, the development of Eclipse 3.0 has centered on the following major themes:

*   _User experience_. This theme deals with all aspects of the end user

experience, especially for new users, the so-called out-of-box experience. This theme also focuses on UI scalability, affordances, improved file-encoding support, key bindings, editor management, text editor presentation, workspace selection, and the introduction of an SWT browser widget.</li>

*   _Responsive UI_. This involves identifying and reducing the number of places where

users are forced to wait when using Eclipse. Major work on this theme included the introduction of an Eclipse concurrency architecture and tackling the performance gap in Eclipse between Windows and other platforms, such as Linux GTK, QNX, and Mac. 

*   _Rich client platform_. The Eclipse APIs have been

reorganized to better support development of applications outside the development tools domain. Work on this theme also included a new infrastructure for storing user settings and support for dynamic installation and removal of plug-ins.

*   _Extended Java family_. This theme deals only with the Java development tools

subproject. Work in this area focused on opening up the JDT APIs to better support Java-like source files, such as Java Server Pages (JSPs) and SQLj. This included opening up the refactoring and Java search infrastructure to facilitate participation by third-party plug-ins.
  

See Also:
---------

[FAQ Is Eclipse 3.0 going to break all of my old plug-ins?](./FAQ_Is_Eclipse_3.0_going_to_break_all_of_my_old_plug-ins.md "FAQ Is Eclipse 3.0 going to break all of my old plug-ins?")

  

